import DataLoader from 'dataloader';
import type { PoolClient } from 'pg';
import { AdminContextProvider } from '../../admin-context/providers/admin-context.provider.js';
import { TenantAwareDBClient } from '../../app-providers/tenant-db-client.js';
import type { IGetAllSortCodesResult, IInsertSortCodeParams, IInsertSortCodesParams, IUpdateSortCodeParams } from '../types.js';
export declare class SortCodesProvider {
    private db;
    private adminContextProvider;
    constructor(db: TenantAwareDBClient, adminContextProvider: AdminContextProvider);
    private allSortCodesCache;
    getAllSortCodes(): Promise<IGetAllSortCodesResult[]>;
    private batchSortCodesByOwnerIds;
    getSortCodesByOwnerIdLoader: DataLoader<string, import("../types.js").IGetSortCodesByOwnerIdsResult[], string>;
    private batchSortCodesByIds;
    getSortCodesByIdLoader: DataLoader<{
        key: number;
        ownerId: string;
    }, import("../types.js").IGetSortCodesByIdsResult | undefined, {
        key: number;
        ownerId: string;
    }>;
    addSortCode(params: IInsertSortCodeParams): Promise<import("../types.js").IInsertSortCodeResult[]>;
    addSortCodes(params: IInsertSortCodesParams, client?: PoolClient): Promise<import("../types.js").IInsertSortCodesResult[]>;
    updateSortCode(params: IUpdateSortCodeParams): Promise<import("../types.js").IUpdateSortCodeResult[]>;
    clearCache(): void;
}
